c
c   main program of cSA to solve constrained problems
c
        parameter(nx=2, nc=1, neqc=1)
        parameter(neq=nx+nc, nineqc=nc-neqc)

        common /prbCSA/nx00, nc00, neqc00, nineqc00

        parameter(nprt=3, nchd=3)
        parameter(ntot=nprt+nchd)
        double precision xx(nprt,neq)

        common /mSA/ mSA
        common /mLag/ mLag
        double precision rleq
        common /rleq/ rleq

        double precision x(neq), t0, tf, rt
        double precision xobj, xvio, topobj, avgobj, botobj
        double precision lb(nx), ub(nx)

        logical hasdiscrete, needshift 
        common /hasdiscrete/ hasdiscrete, needshift
        integer isdx 
        common /isdx/ isdx(nx)
        double precision ndsample
        common /ndsample/ ndsample(nx)
        double precision xshift, xstep
        common /discrete/ xshift(nx), xstep(nx)

        integer nSAIter
        common /nSAIter/ nSAIter

        logical used
        character*20 filename

        real tarray(2), etime, dtime, x0RANMAR, begt, endt
        double precision Dint

        double precision slobj
        common /slobj/ slobj

        integer mPen
        common /mPen/ mPen

c    use for Gaussian neighborhood
        integer iGset
        double precision rGset
        common /GaussSet/ iGset, rGset

c    use for tuning
        logical cSAtuning

c    reuse already calculated obj, ceq, cineq in pSA
c    set reuse=.TRUE. ONLY for pSA
        logical reuse
        common /reuse/ reuse 
        reuse=.FALSE.
       
        iGset=0

c    problem size statistics
        nx00=nx
        nc00=nc
        neqc00=neqc
        nineqc00=nineqc

c    initialize problem-dependent data for cSA
        call init_cSA_pd()

c    if tuning CSA, set cSAtuning=.TRUE.
c        cSAtuning=.TRUE.
        cSAtuning=.FALSE.

c    Check type of variables, generate grid

        hasdiscrete=.FALSE.
        call xdiscrete(nx,isdx)
        do 10 i=1,nx
            if(isdx(i).EQ.1) hasdiscrete=.TRUE.
10      continue
        call dxinfo(nx,xstep,xshift)
        print *, "xstep = ", (xstep(i),i=1,nx)
        needshift=.FALSE. 
        print *, "hasdiscrete = ", hasdiscrete, "   needshift = ", needshift
        print *, "obj scale = ", slobj
        call flush(6)

        print *, "Special use for Lancelot results (0-no, 1-x_unchanged, 2-x_stepdis)? ="
        read *, sulan

c   Get discretized value for Lancelot solutions

        if(sulan.EQ.1) then 
           filename = "lan0"
           call xbound(nx,lb,ub)
           inquire(file=filename, exist=used)
           if(used) then
               open(unit = 20, file = filename, status='old',iostat=ierr)
               if(ierr.ne.0) print *, "Open file ",filename, "error",ierr
               read (20,*) (x(i), i=1,nx)
               close(unit = 20)
           else
               print *, "File ", filename, " doesn't exist!"
               stop
           endif 
         
           print *,"X   = ", (x(i) , i=1,nx)
           print *,"BL  = ", (lb(i), i=1,nx)
           print *,"BU  = ", (ub(i), i=1,nx)
           print *,"Vio = ", sh_oviomax(x)
           print *,"Obj = ", sh_obj(nx,x) 

        stop
        endif

        if(sulan.EQ.2) then 
           filename = "lan0"
           call xbound(nx,lb,ub)
           inquire(file=filename, exist=used)
           if(used) then
               open(unit = 20, file = filename, status='old',iostat=ierr)
               if(ierr.ne.0) print *, "Open file ",filename, "error",ierr
               read (20,*) (x(i), i=1,nx)
               close(unit = 20)
           else
               print *, "File ", filename, " doesn't exist!"
               stop
           endif 
         
          print *,"Original X=",(x(i), i=1,nx)
          print *,"Vio = ", sh_oviomax(x), "Obj =", sh_obj(nx,x) 
          print *,"Isdx =",(isdx(i), i=1,nx) 

c  Adjust xstep, CSA must also be adjusted
c          do i=1,nx
c             xstep(i) = xstep(i) * 100.0
c          enddo           

          do i=1,nx
            if(isdx(i).EQ.1) then
             if( (x(i).GT.ub(i)).OR.(x(i).LT.lb(i)) ) then
                 print *,"Error: Out of bound"
                 stop
             endif    
             nsteps = int(( x(i) - lb(i) )/xstep(i))
             simx = lb(i) + nsteps*xstep(i)
             simxx= lb(i) + (nsteps+1)*xstep(i)
             if((x(i)-simx).LT.(simxx-x(i))) then
                x(i)=simx
             else
                x(i)=simxx
             endif
            endif
          enddo 

          print *,"==>"          
          print *,"Discretized X=",(x(i),i=1,nx)
          print *,"Vio | Obj "
          print *,"& ", sh_oviomax(x)," & ", sh_obj(nx,x), " & "  
        stop
        endif

        print *, "Input scale slobj for obj (obj/slobj) ="
        read *, slobj

        begt=etime(tarray)

        mLag=3

        print *, "Lagrange function/(0,1,2,3,4,5,10)"
        read *, mLag
        if(mLag.EQ.10) then
            mSA=10
            print *, "Input initial relaxed size for equality = "
            read *, rleq
        else
            print *, "cSA rule/(0 - cSA, 1 - pSA)"
            read *, mSA
            if(mSA.GE.2) then
                print *, "Wrong cSA rule in main !"
                stop
            endif
        endif

c
c penalty methods    
c 
        print *, "Penalty methods/(0-CSA,1-static,2-P3,3-P4)"
        read *, mPen
    

        print *, "Multi-level CSA/(0,1)"
        read *, mlevelCSA
        if(mlevelCSA.EQ.1) then
            print *, "Input #consecutive NTs for stop"
            read *, nNT
        endif

        print *, "Multi start /(0,1)"
        read *, mstart
        if(mstart.EQ.1) then
            print *, "Input number of runs = "
            read *, mrun
            if(mrun.LT.1) then
                print *, "Wrong run number in main !"
                stop
            endif
        else if(mstart.NE.0) then
            print *, "Wrong running mode in main !"
            stop
        endif

        call init_T(t0,tf)

        print *, "Input ratio of reducing T ="
        read *, rt


        call initial_donlp2()

        ntotIter=0

        if(mstart.EQ.0) then
            print *, "Input file name for starting point:"
            read *, filename
            inquire(file=filename, exist=used)
            if(used) then
                open(unit = 20, file = filename, status='old', iostat=ierr)
                if(ierr.ne.0) print *, "Open file ",filename, " error ",ierr
                read (20,*) (x(i), i=1,nx)
                close(unit = 20)
            else
                print*, "File ", filename, " doesn't exist!"
                stop
            endif

            do 50 i=nx+1,neq
                x(i)=0.0D0
50          continue
            print *, " "
            print *, "x0 = ",(x(j),j=1,nx)

            mrun=1
            nsucc=0

            if(mlevelCSA.EQ.0) then
                call by_csa(msol,xx,x,xobj,xvio,t0,rt)
            else
                call by_mcsa(msol,nNT,xx,x,xobj,xvio,t0,rt)
            endif

            if(msol.EQ.1) then
                nsucc=nsucc+1
                ntotIter=ntotIter+nSAIter
            endif
        else

C    Set random generator for starting points x0 
            if(.NOT.cSAtuning) then
               ISEED1=1
               ISEED2=2
               CALL x0RMARIN(ISEED1,ISEED2)
            endif

            nsucc=0
            topobj=1.0D20
            avgobj=0.0D0
            botobj=(-1.0D20)
            call xbound(nx,lb,ub)

            do 60 m=1,mrun

                begt=dtime(tarray)

                if(cSAtuning) IFAIL=1

65              if(cSAtuning) then
                    ISEED1=7*m
                    ISEED2=5*IFAIL
                    CALL x0RMARIN(ISEED1,ISEED2)
                endif

                if(mSA.EQ.1) then
                    do 80 i=1,nprt
                        do 85 j=1,nx
                            if(isdx(j).EQ.1) then
                                xx(i,j)=lb(j)+Dint(x0RANMAR()*ndsample(j))*xstep(j)
                            else
                                xx(i,j)=lb(j)+(ub(j)-lb(j))*x0RANMAR()
                            endif
85                      continue
                        do 86 j=nx+1,neq
                            xx(i,j)=0.0D0
86                      continue
80                  continue
                else
                    do 70 j=1,nx
                        if(isdx(j).EQ.1) then
                            x(j)=lb(j)+Dint(x0RANMAR()*ndsample(j))*xstep(j)
                        else
                            x(j)=lb(j)+(ub(j)-lb(j))*x0RANMAR()
                        endif
70                  continue
                    do 75 j=nx+1,neq
                        x(j)=0.0D0
75                  continue
                endif
                print *, " "
                print *, "x0 = ",(x(j),j=1,nx)

                if(mlevelCSA.EQ.0) then
                   call by_csa(msol,xx,x,xobj,xvio,t0,rt)
                else
                   call by_mcsa(msol,nNT,xx,x,xobj,xvio,t0,rt)
                endif

                if(.NOT.cSAtuning) endt=dtime(tarray)

                if(msol.EQ.1) then
                   if(cSAtuning) endt=dtime(tarray)
                   print *, "run_id =", m, " : Obj =", xobj, " time =", endt
                   nsucc=nsucc+1
                   ntotIter=ntotIter+nSAIter
                   if(xobj.LT.topobj) topobj=xobj
                   if(xobj.GT.botobj) botobj=xobj
                   avgobj=avgobj+xobj
                else
                   if(cSAtuning) then
                      print *, "run_Id =", m, "  Fail run_Id =", IFAIL
                      IFAIL=IFAIL+1
                      call flush(6)
                      if(IFAIL.GT.100) stop
                      goto 65
                   else
                      print *, "run_id =", m, " : obj =", 1.0D20, " time =", endt
                   endif
                endif
                call flush(6)
60          continue

            print *, "========== Obj Summary of ", mrun," runs ========== "
            print *, " best Obj = ", topobj, ",  worst Obj = ", botobj
            if(nsucc.GT.0) print *, " avrg Obj = ", avgobj/nsucc
        endif

        if(nsucc.GT.0) then
            print *, nsucc, " success run, time per Obj = ", etime(tarray)/mrun, 
     1               " sec,  ", "iter = ", log(dble(ntotIter)/nsucc)/log(2.0D0)
        else
            print *, "0 success run, time per Obj = ", etime(tarray)/mrun
        endif

        stop
        end

c
c   Compute initial temperature T
c
        subroutine init_T(t0,tf)
        double precision t0, tf

        parameter(nx=2, nc=1)
        parameter(neq=nx+nc)

        real RANMAR
        double precision lb(nx), ub(nx), dlag, ocst
        double precision dlmax, dl, dx, x0(neq), x1(neq)

c        print *, "Input random seed = "
c        read *, iseed
        iseed=123
        ii=irand(iseed)

C       Initialize the random number generator RANMAR.
        ISEED1=3
        ISEED2=4
        CALL RMARIN(ISEED1,ISEED2)

        dlmax=0.0D0
        call xbound(nx,lb,ub)

        do 10 i=1,100
           do 15 j=1,nx
              x0(j)=lb(j)+(ub(j)-lb(j))*RANMAR()
              dx=(ub(j)-lb(j))*0.001D0*(RANMAR()*2.0D0-1.0D0)
              if(dx.LT.0.01D0) dx=0.01D0
              x1(j)=x0(j)+dx
              if(x1(j).LT.lb(j)) then
                  x1(j)=lb(j)+1.0D-6
              else if(x1(j).GT.ub(j)) then
                  x1(j)=ub(j)-1.0D-6
              endif
15         continue
           do 20 j=nx+1,neq
              x0(j)=1.0D0
              x1(j)=1.0D0
20         continue

           dl=abs(dlag(x1)-dlag(x0))
           if(dl.GT.dlmax) dlmax=dl
           do 25 j=nx+1,neq
              dl=ocst((j-nx),nx,x0)
              if(dl.GT.dlmax) dlmax=dl
25         continue
10      continue

        t0=dlmax
        if(t0.LT.1.0D0) t0=1.0D0
        if(t0.GT.1.0D3) t0=1.0D3

        tf=dlmax/1.0D3
        if(tf.GT.1.0D-3) tf=1.0D-3
        print *,"Initial temperature t0 = ", t0, "  Stop tf = ", tf

        return
        end

c
c   Initialize donlp2
c
        subroutine initial_donlp2()

        include 'O8BLOC.INC'

        integer nx00, nc, neqc, nineqc

        parameter(nx00=2, nc=5, neqc=1)
        parameter(nineqc=nc-neqc)

        integer nxx, ncc, neqcc, nineqcc
        common /prbSQP/ nxx, ncc, neqcc, nineqcc

        data del0/1.00d2/, tau0/1.d4/, tau/.1d0/

        n=nx00
        nh=neqc
        ng=nineqc

        nxx=nx00
        ncc=nc
        neqcc=neqc
        nineqcc=nineqc

c   initialize problem-dependent data for SQP
        call init_SQP_pd()

        return 
        end

c
c   vviomax(nx,x): maximal unsatisfication of constraints
c       nx --- variable dimension
c       x --- primary and dual variables
c
        double precision function vviomax(n,x)
        double precision x(*), Dabs, Dmax1
        double precision cceq, ccineq, val

        parameter(nx=2, nc=5, neqc0=1)
        parameter(nineqc0=nc-neqc0)

        neqc=neqc0
        nineqc=nineqc0

        vviomax=0.0D0

        do 5 m=1,neqc
            val=Dabs(cceq(m,nx,x))
            if(val.GT.vviomax) vviomax=val
5       continue

        do 10 m=1,nineqc
            val=Dmax1(0.0D0,ccineq(m,nx,x))
            if(val.GT.vviomax) vviomax=val
10      continue

        return
        end

